// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
// -*-C++-*-
//
// File:      DopeVector.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Fri Aug  9 16:47:44 MEST 2002

#ifndef DopeVector_h
#define DopeVector_h
#include <f90cxx.h>

/*
  Templated interface to F90 vectors of a particular type.

 */

template<typename T>
struct DopeVector : public Dope<T, 1 >
{
public:

  int length() const
  {
    return dim[0].extent;
  }

  int lbound() const
  {
    return dim[0].lower;
  }

  int ubound() const
  {
    return dim[0].lower+dim[0].extent-1;
  }

  T& operator[]( unsigned long idx ) const
  {
    return *(T*)((int)addr + (dim[0].mult*idx + offset));
  }

  int sizeOfType() const {
    return sizeof(T);
  }

private:
};

#endif
