// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
// -*-C++-*-
//
// File:      omsource.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Fri Aug  9 17:05:36 MEST 2002
#include "usnochecker.h"
#include <iostream>
#include "Dal.h"
void usnochecker()
{
  


    string fileName = stringParameter( "set");
   

    // Open the file
    DataSet *dataSet = dataSetServer->open(fileName, Dal::Read);
   

    // Read the table
    const Table *table = dataSet->table( "RAWRES" );

    int size = table->rows();

 
    int count = 0;
    if (table->hasColumn( "BMAG" ))
    {
        const ColumnData *columnData = table->column( "BMAG" )->data();
    



        float *data = columnData->real32Data();
    
  
        for (int i=0; i < size; i++)
        {
	  if ( data[i] > 0.0 && data[i] < 30.0) count++; 

        }



    }
    int count1 = count;
    if (table->hasColumn( "RMAG" ))
    {
 

        const ColumnData *columnData1 = table->column( "RMAG" )->data();
    



        float *data = columnData1->real32Data();
        count1 = 0;    
      
        for (int i=0; i < size; i++)
        {
	  if ( data[i] > 0.0 && data[i] < 30.0) count1++; 

        }



     }

     dataSetServer->close(dataSet); // Finished with the file



    
	cout << "line 68 size=" << size << " count=" << count << " count1=" << count1 << endl;

        if (count < size / 4 || count < count1 / 2 ) {
            cout << "size=" << size << " count=" << count << endl;

            Sas::fatal("Useless USNO catalogue", "test");
	    cout << "called sas fatal\n";
	}

   


 

};




